library IsmAvatar;

uses dos, sysutils;

function stp(s : string) : pchar;
var
 p : pchar;
begin
 p := stralloc(length(s)+1);
 strpcopy(p,s);
 stp := p;
end;

function _getattr(fn : pchar) : real; stdcall;
var
 f : file;
 w : word;
begin
 assign(f,fn);
 getFAttr(f,w);
 _getattr := real(w);
end;

function _getsattr(fn : pchar) : pchar; stdcall;
var
 f : file;
 w : word;
 r : string;
begin
 assign(f,fn);
 getFAttr(f,w);
 r := '';
 if (w and archive) <> 0 then r += 'a';
 if (w and directory) <> 0 then r += 'd';
 if (w and hidden) <> 0 then r += 'h';
 if (w and readonly) <> 0 then r += 'r';
 if (w and sysfile) <> 0 then r += 's';
 _getsattr := stp(r);
end;

function _setattr(fn : pchar; a : real) : real; stdcall;
var f : file;
begin
 assign(f,fn);
 setFAttr(f,trunc(a));
 _setattr := 0;
end;

function _setsattr(fn,s : pchar) : real; stdcall;
var
 f : file;
 s2 : pchar;
 w : word;
begin
 assign(f,fn);
 s2 := StrAlloc(Strlen(s)+1);
 StrCopy(s2,s);
 s2 := strlower(s2);
 w := 0;
 if strscan(s2,'a') <> nil then w := w or archive;
 if strscan(s2,'d') <> nil then w := w or directory;
 if strscan(s2,'h') <> nil then w := w or hidden;
 if strscan(s2,'r') <> nil then w := w or readonly;
 if strscan(s2,'s') <> nil then w := w or sysfile;
 setFAttr(f,w);
 strdispose(s2);
 _setsattr := 0;
end;

exports _getattr, _getsattr, _setattr, _setsattr;
begin end.
